function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
import { defineComponent, $prefix, $props, $setup } from "@dft-vue-2-opentiny/vue-common";
import PcTemplate from "./pc.js";
import "@dft-vue-2-opentiny/vue-theme/cascader/index.css";
var template = function template2(mode) {
  return PcTemplate;
};
var $constants = {
  placeholder: "ui.cascader.placeholder",
  COMPONENT_NAME: {
    FormItem: "FormItem"
  },
  EVENT_NAME: {
    FormBlur: "form.blur"
  }
};
var Cascader = defineComponent({
  name: $prefix + "Cascader",
  props: _extends({}, $props, {
    _constants: {
      type: Object,
      default: function _default() {
        return $constants;
      }
    },
    autoSize: Boolean,
    beforeFilter: {
      type: Function,
      default: function _default2() {
        return function() {
        };
      }
    },
    clearable: Boolean,
    collapseTags: Boolean,
    debounce: {
      type: Number,
      default: 300
    },
    disabled: Boolean,
    filterMethod: Function,
    filterable: Boolean,
    modelValue: {},
    options: Array,
    placeholder: {
      type: String,
      default: ""
    },
    popperAppendToBody: {
      type: Boolean,
      default: true
    },
    popperClass: String,
    props: Object,
    separator: {
      type: String,
      default: "/"
    },
    showAllLevels: {
      type: Boolean,
      default: true
    },
    size: String,
    shape: String,
    label: String,
    tip: String,
    displayOnly: {
      type: Boolean,
      default: false
    },
    hoverExpand: {
      type: Boolean,
      default: false
    }
  }),
  setup: function setup(props, context) {
    return $setup({
      props,
      context,
      template
    });
  }
});
var version = "2.8.0";
Cascader.model = {
  prop: "modelValue",
  event: "update:modelValue"
};
Cascader.install = function(Vue) {
  Vue.component(Cascader.name, Cascader);
};
Cascader.version = version;
export {
  Cascader as default
};
